// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::PatternSpec;
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlPreferencesGroup")]
    pub struct PreferencesGroup(Object<ffi::DzlPreferencesGroup, ffi::DzlPreferencesGroupClass>) @extends gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_preferences_group_get_type(),
    }
}

impl PreferencesGroup {
    #[doc(alias = "dzl_preferences_group_add")]
    pub fn add(&self, widget: &impl IsA<gtk::Widget>) {
        unsafe {
            ffi::dzl_preferences_group_add(self.to_glib_none().0, widget.as_ref().to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_preferences_group_get_priority")]
    #[doc(alias = "get_priority")]
    pub fn priority(&self) -> i32 {
        unsafe { ffi::dzl_preferences_group_get_priority(self.to_glib_none().0) }
    }

    #[doc(alias = "dzl_preferences_group_get_size_group")]
    #[doc(alias = "get_size_group")]
    pub fn size_group(&self, column: u32) -> Option<gtk::SizeGroup> {
        unsafe {
            from_glib_none(ffi::dzl_preferences_group_get_size_group(
                self.to_glib_none().0,
                column,
            ))
        }
    }

    #[doc(alias = "dzl_preferences_group_get_title")]
    #[doc(alias = "get_title")]
    pub fn title(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::dzl_preferences_group_get_title(self.to_glib_none().0)) }
    }

    #[doc(alias = "dzl_preferences_group_refilter")]
    pub fn refilter(&self, spec: &PatternSpec) -> u32 {
        unsafe { ffi::dzl_preferences_group_refilter(self.to_glib_none().0, spec.to_glib_none().0) }
    }

    //#[doc(alias = "dzl_preferences_group_set_map")]
    //pub fn set_map(&self, map: /*Unknown conversion*//*Unimplemented*/HashTable TypeId { ns_id: 0, id: 25 }/TypeId { ns_id: 0, id: 25 }) {
    //    unsafe { TODO: call ffi:dzl_preferences_group_set_map() }
    //}

    #[doc(alias = "is-list")]
    pub fn is_list(&self) -> bool {
        ObjectExt::property(self, "is-list")
    }

    pub fn mode(&self) -> gtk::SelectionMode {
        ObjectExt::property(self, "mode")
    }

    pub fn set_mode(&self, mode: gtk::SelectionMode) {
        ObjectExt::set_property(self, "mode", mode)
    }

    #[doc(alias = "mode")]
    pub fn connect_mode_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_mode_trampoline<F: Fn(&PreferencesGroup) + 'static>(
            this: *mut ffi::DzlPreferencesGroup,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::mode\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_mode_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl fmt::Display for PreferencesGroup {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("PreferencesGroup")
    }
}
